// This file is generated by kconfig_compiler_kf5 from spectacle.kcfg.
// All changes you do to this file will be lost.
#ifndef SETTINGS_H
#define SETTINGS_H

#include <kconfigskeleton.h>
#include <QCoreApplication>
#include <QDebug>

#include <QStandardPaths>
#include <SpectacleCommon.h>

class Settings : public KConfigSkeleton
{
  public:
    enum EnumOnLaunchAction { TakeFullscreenScreenshot, UseLastUsedCapturemode, DoNotTakeScreenshot };
    enum EnumPrintKeyActionRunning { TakeNewScreenshot, StartNewInstance, FocusWindow };
    enum EnumClipboardGroup { PostScreenshotDoNothing, PostScreenshotCopyImage, PostScreenshotCopyLocation };
    enum EnumRememberLastRectangularRegion { Never, Always, UntilSpectacleIsClosed };
    enum EnumLastUsedSaveMode { SaveAs, Save };
    enum EnumLastUsedCopyMode { CopyLocation, CopyImage };

    static Settings *self();
    ~Settings() override;

    /**
      Set What to do when Spectacle is launched
    */
    static
    void setOnLaunchAction( EnumOnLaunchAction v )
    {
      if (!self()->isOnLaunchActionImmutable())
        self()->mOnLaunchAction = v;
    }

    /**
      Get What to do when Spectacle is launched
    */
    static
    EnumOnLaunchAction onLaunchAction()
    {
      return static_cast<EnumOnLaunchAction>(self()->mOnLaunchAction);
    }

    /**
      Is What to do when Spectacle is launched Immutable
    */
    static
    bool isOnLaunchActionImmutable()
    {
      return self()->isImmutable( QStringLiteral( "onLaunchAction" ) );
    }

    /**
      Set What should happen if print key is pressed when Spectacle is already running
    */
    static
    void setPrintKeyActionRunning( EnumPrintKeyActionRunning v )
    {
      if (!self()->isPrintKeyActionRunningImmutable())
        self()->mPrintKeyActionRunning = v;
    }

    /**
      Get What should happen if print key is pressed when Spectacle is already running
    */
    static
    EnumPrintKeyActionRunning printKeyActionRunning()
    {
      return static_cast<EnumPrintKeyActionRunning>(self()->mPrintKeyActionRunning);
    }

    /**
      Is What should happen if print key is pressed when Spectacle is already running Immutable
    */
    static
    bool isPrintKeyActionRunningImmutable()
    {
      return self()->isImmutable( QStringLiteral( "printKeyActionRunning" ) );
    }

    /**
      Set Save screenshot automatically after it is taken
    */
    static
    void setAutoSaveImage( bool v )
    {
      if (!self()->isAutoSaveImageImmutable())
        self()->mAutoSaveImage = v;
    }

    /**
      Get Save screenshot automatically after it is taken
    */
    static
    bool autoSaveImage()
    {
      return self()->mAutoSaveImage;
    }

    /**
      Is Save screenshot automatically after it is taken Immutable
    */
    static
    bool isAutoSaveImageImmutable()
    {
      return self()->isImmutable( QStringLiteral( "autoSaveImage" ) );
    }

    /**
      Set Clipboard action which should be executed after the screenshot is taken
    */
    static
    void setClipboardGroup( EnumClipboardGroup v )
    {
      if (!self()->isClipboardGroupImmutable())
        self()->mClipboardGroup = v;
    }

    /**
      Get Clipboard action which should be executed after the screenshot is taken
    */
    static
    EnumClipboardGroup clipboardGroup()
    {
      return static_cast<EnumClipboardGroup>(self()->mClipboardGroup);
    }

    /**
      Is Clipboard action which should be executed after the screenshot is taken Immutable
    */
    static
    bool isClipboardGroupImmutable()
    {
      return self()->isImmutable( QStringLiteral( "clipboardGroup" ) );
    }

    /**
      Set Whether to use a light color mask in the region selection dialog
    */
    static
    void setUseLightMaskColour( bool v )
    {
      if (!self()->isUseLightMaskColourImmutable())
        self()->mUseLightMaskColour = v;
    }

    /**
      Get Whether to use a light color mask in the region selection dialog
    */
    static
    bool useLightMaskColour()
    {
      return self()->mUseLightMaskColour;
    }

    /**
      Is Whether to use a light color mask in the region selection dialog Immutable
    */
    static
    bool isUseLightMaskColourImmutable()
    {
      return self()->isImmutable( QStringLiteral( "useLightMaskColour" ) );
    }

    /**
      Set Whether to show a magnifier in the region selection
    */
    static
    void setShowMagnifier( bool v )
    {
      if (!self()->isShowMagnifierImmutable())
        self()->mShowMagnifier = v;
    }

    /**
      Get Whether to show a magnifier in the region selection
    */
    static
    bool showMagnifier()
    {
      return self()->mShowMagnifier;
    }

    /**
      Is Whether to show a magnifier in the region selection Immutable
    */
    static
    bool isShowMagnifierImmutable()
    {
      return self()->isImmutable( QStringLiteral( "showMagnifier" ) );
    }

    /**
      Set Whether the screenshot should be captured after selecting the region and releasing the mouse
    */
    static
    void setUseReleaseToCapture( bool v )
    {
      if (!self()->isUseReleaseToCaptureImmutable())
        self()->mUseReleaseToCapture = v;
    }

    /**
      Get Whether the screenshot should be captured after selecting the region and releasing the mouse
    */
    static
    bool useReleaseToCapture()
    {
      return self()->mUseReleaseToCapture;
    }

    /**
      Is Whether the screenshot should be captured after selecting the region and releasing the mouse Immutable
    */
    static
    bool isUseReleaseToCaptureImmutable()
    {
      return self()->isImmutable( QStringLiteral( "useReleaseToCapture" ) );
    }

    /**
      Set Whether to show capture instructions in the region selection
    */
    static
    void setShowCaptureInstructions( bool v )
    {
      if (!self()->isShowCaptureInstructionsImmutable())
        self()->mShowCaptureInstructions = v;
    }

    /**
      Get Whether to show capture instructions in the region selection
    */
    static
    bool showCaptureInstructions()
    {
      return self()->mShowCaptureInstructions;
    }

    /**
      Is Whether to show capture instructions in the region selection Immutable
    */
    static
    bool isShowCaptureInstructionsImmutable()
    {
      return self()->isImmutable( QStringLiteral( "showCaptureInstructions" ) );
    }

    /**
      Set Remember the last rectangular region
    */
    static
    void setRememberLastRectangularRegion( EnumRememberLastRectangularRegion v )
    {
      if (!self()->isRememberLastRectangularRegionImmutable())
        self()->mRememberLastRectangularRegion = v;
    }

    /**
      Get Remember the last rectangular region
    */
    static
    EnumRememberLastRectangularRegion rememberLastRectangularRegion()
    {
      return static_cast<EnumRememberLastRectangularRegion>(self()->mRememberLastRectangularRegion);
    }

    /**
      Is Remember the last rectangular region Immutable
    */
    static
    bool isRememberLastRectangularRegionImmutable()
    {
      return self()->isImmutable( QStringLiteral( "rememberLastRectangularRegion" ) );
    }

    /**
      Set The last used region the user selected
    */
    static
    void setCropRegion( const QList<int> & v )
    {
      if (!self()->isCropRegionImmutable())
        self()->mCropRegion = v;
    }

    /**
      Get The last used region the user selected
    */
    static
    QList<int> cropRegion()
    {
      return self()->mCropRegion;
    }

    /**
      Is The last used region the user selected Immutable
    */
    static
    bool isCropRegionImmutable()
    {
      return self()->isImmutable( QStringLiteral( "cropRegion" ) );
    }

    /**
      Set Take screenshot on click
    */
    static
    void setOnClickChecked( bool v )
    {
      if (!self()->isOnClickCheckedImmutable())
        self()->mOnClickChecked = v;
    }

    /**
      Get Take screenshot on click
    */
    static
    bool onClickChecked()
    {
      return self()->mOnClickChecked;
    }

    /**
      Is Take screenshot on click Immutable
    */
    static
    bool isOnClickCheckedImmutable()
    {
      return self()->isImmutable( QStringLiteral( "onClickChecked" ) );
    }

    /**
      Set Whether the mouse cursor is included in the screenshot
    */
    static
    void setIncludePointer( bool v )
    {
      if (!self()->isIncludePointerImmutable())
        self()->mIncludePointer = v;
    }

    /**
      Get Whether the mouse cursor is included in the screenshot
    */
    static
    bool includePointer()
    {
      return self()->mIncludePointer;
    }

    /**
      Is Whether the mouse cursor is included in the screenshot Immutable
    */
    static
    bool isIncludePointerImmutable()
    {
      return self()->isImmutable( QStringLiteral( "includePointer" ) );
    }

    /**
      Set Whether the window decorations are included in the screenshot
    */
    static
    void setIncludeDecorations( bool v )
    {
      if (!self()->isIncludeDecorationsImmutable())
        self()->mIncludeDecorations = v;
    }

    /**
      Get Whether the window decorations are included in the screenshot
    */
    static
    bool includeDecorations()
    {
      return self()->mIncludeDecorations;
    }

    /**
      Is Whether the window decorations are included in the screenshot Immutable
    */
    static
    bool isIncludeDecorationsImmutable()
    {
      return self()->isImmutable( QStringLiteral( "includeDecorations" ) );
    }

    /**
      Set Only capture the current pop up menu
    */
    static
    void setTransientOnly( bool v )
    {
      if (!self()->isTransientOnlyImmutable())
        self()->mTransientOnly = v;
    }

    /**
      Get Only capture the current pop up menu
    */
    static
    bool transientOnly()
    {
      return self()->mTransientOnly;
    }

    /**
      Is Only capture the current pop up menu Immutable
    */
    static
    bool isTransientOnlyImmutable()
    {
      return self()->isImmutable( QStringLiteral( "transientOnly" ) );
    }

    /**
      Set Quit after saving or copying an image
    */
    static
    void setQuitAfterSaveCopyExport( bool v )
    {
      if (!self()->isQuitAfterSaveCopyExportImmutable())
        self()->mQuitAfterSaveCopyExport = v;
    }

    /**
      Get Quit after saving or copying an image
    */
    static
    bool quitAfterSaveCopyExport()
    {
      return self()->mQuitAfterSaveCopyExport;
    }

    /**
      Is Quit after saving or copying an image Immutable
    */
    static
    bool isQuitAfterSaveCopyExportImmutable()
    {
      return self()->isImmutable( QStringLiteral( "quitAfterSaveCopyExport" ) );
    }

    /**
      Set Delay
    */
    static
    void setCaptureDelay( double v )
    {
      if (!self()->isCaptureDelayImmutable())
        self()->mCaptureDelay = v;
    }

    /**
      Get Delay
    */
    static
    double captureDelay()
    {
      return self()->mCaptureDelay;
    }

    /**
      Is Delay Immutable
    */
    static
    bool isCaptureDelayImmutable()
    {
      return self()->isImmutable( QStringLiteral( "captureDelay" ) );
    }

    /**
      Set captureMode
    */
    static
    void setCaptureMode( Spectacle::CaptureMode v )
    {
      if (!self()->isCaptureModeImmutable())
        self()->mCaptureMode = v;
    }

    /**
      Get captureMode
    */
    static
    Spectacle::CaptureMode captureMode()
    {
      return static_cast<Spectacle::CaptureMode>(self()->mCaptureMode);
    }

    /**
      Is captureMode Immutable
    */
    static
    bool isCaptureModeImmutable()
    {
      return self()->isImmutable( QStringLiteral( "captureMode" ) );
    }

    /**
      Set Default filename
    */
    static
    void setDefaultSaveLocation( const QUrl & v )
    {
      if (!self()->isDefaultSaveLocationImmutable())
        self()->mDefaultSaveLocation = v;
    }

    /**
      Get Default filename
    */
    static
    QUrl defaultSaveLocation()
    {
      return self()->mDefaultSaveLocation;
    }

    /**
      Is Default filename Immutable
    */
    static
    bool isDefaultSaveLocationImmutable()
    {
      return self()->isImmutable( QStringLiteral( "defaultSaveLocation" ) );
    }

    /**
      Set Compression quality for lossy file formats
    */
    static
    void setCompressionQuality( uint v )
    {
      if (!self()->isCompressionQualityImmutable())
        self()->mCompressionQuality = v;
    }

    /**
      Get Compression quality for lossy file formats
    */
    static
    uint compressionQuality()
    {
      return self()->mCompressionQuality;
    }

    /**
      Is Compression quality for lossy file formats Immutable
    */
    static
    bool isCompressionQualityImmutable()
    {
      return self()->isImmutable( QStringLiteral( "compressionQuality" ) );
    }

    /**
      Set Default save image format
    */
    static
    void setDefaultSaveImageFormat( const QString & v )
    {
      if (!self()->isDefaultSaveImageFormatImmutable())
        self()->mDefaultSaveImageFormat = v;
    }

    /**
      Get Default save image format
    */
    static
    QString defaultSaveImageFormat()
    {
      return self()->mDefaultSaveImageFormat;
    }

    /**
      Is Default save image format Immutable
    */
    static
    bool isDefaultSaveImageFormatImmutable()
    {
      return self()->isImmutable( QStringLiteral( "defaultSaveImageFormat" ) );
    }

    /**
      Set The default filename used when saving
    */
    static
    void setSaveFilenameFormat( const QString & v )
    {
      if (!self()->isSaveFilenameFormatImmutable())
        self()->mSaveFilenameFormat = v;
    }

    /**
      Get The default filename used when saving
    */
    static
    QString saveFilenameFormat()
    {
      return self()->mSaveFilenameFormat;
    }

    /**
      Is The default filename used when saving Immutable
    */
    static
    bool isSaveFilenameFormatImmutable()
    {
      return self()->isImmutable( QStringLiteral( "saveFilenameFormat" ) );
    }

    /**
      Set The path of the file saved last
    */
    static
    void setLastSaveLocation( const QUrl & v )
    {
      if (!self()->isLastSaveLocationImmutable())
        self()->mLastSaveLocation = v;
    }

    /**
      Get The path of the file saved last
    */
    static
    QUrl lastSaveLocation()
    {
      return self()->mLastSaveLocation;
    }

    /**
      Is The path of the file saved last Immutable
    */
    static
    bool isLastSaveLocationImmutable()
    {
      return self()->isImmutable( QStringLiteral( "lastSaveLocation" ) );
    }

    /**
      Set Last path used for "save as" action
    */
    static
    void setLastSaveAsLocation( const QUrl & v )
    {
      if (!self()->isLastSaveAsLocationImmutable())
        self()->mLastSaveAsLocation = v;
    }

    /**
      Get Last path used for "save as" action
    */
    static
    QUrl lastSaveAsLocation()
    {
      return self()->mLastSaveAsLocation;
    }

    /**
      Is Last path used for "save as" action Immutable
    */
    static
    bool isLastSaveAsLocationImmutable()
    {
      return self()->isImmutable( QStringLiteral( "lastSaveAsLocation" ) );
    }

    /**
      Set The last used save mode
    */
    static
    void setLastUsedSaveMode( EnumLastUsedSaveMode v )
    {
      if (!self()->isLastUsedSaveModeImmutable())
        self()->mLastUsedSaveMode = v;
    }

    /**
      Get The last used save mode
    */
    static
    EnumLastUsedSaveMode lastUsedSaveMode()
    {
      return static_cast<EnumLastUsedSaveMode>(self()->mLastUsedSaveMode);
    }

    /**
      Is The last used save mode Immutable
    */
    static
    bool isLastUsedSaveModeImmutable()
    {
      return self()->isImmutable( QStringLiteral( "lastUsedSaveMode" ) );
    }

    /**
      Set The last used copy mode
    */
    static
    void setLastUsedCopyMode( EnumLastUsedCopyMode v )
    {
      if (!self()->isLastUsedCopyModeImmutable())
        self()->mLastUsedCopyMode = v;
    }

    /**
      Get The last used copy mode
    */
    static
    EnumLastUsedCopyMode lastUsedCopyMode()
    {
      return static_cast<EnumLastUsedCopyMode>(self()->mLastUsedCopyMode);
    }

    /**
      Is The last used copy mode Immutable
    */
    static
    bool isLastUsedCopyModeImmutable()
    {
      return self()->isImmutable( QStringLiteral( "lastUsedCopyMode" ) );
    }

  protected:
    Settings();
    friend class SettingsHelper;


    // General
    int mOnLaunchAction;
    int mPrintKeyActionRunning;
    bool mAutoSaveImage;
    int mClipboardGroup;
    bool mUseLightMaskColour;
    bool mShowMagnifier;
    bool mUseReleaseToCapture;
    bool mShowCaptureInstructions;
    int mRememberLastRectangularRegion;

    // GuiConfig
    QList<int> mCropRegion;
    bool mOnClickChecked;
    bool mIncludePointer;
    bool mIncludeDecorations;
    bool mTransientOnly;
    bool mQuitAfterSaveCopyExport;
    double mCaptureDelay;
    int mCaptureMode;

    // Save
    QUrl mDefaultSaveLocation;
    uint mCompressionQuality;
    QString mDefaultSaveImageFormat;
    QString mSaveFilenameFormat;
    QUrl mLastSaveLocation;
    QUrl mLastSaveAsLocation;
    int mLastUsedSaveMode;
    int mLastUsedCopyMode;

  private:
};

#endif

